/// The Syncfusion Flutter Calendar widget has built-in configurable views that
/// provide basic functionalities for scheduling and representing appointments/events efficiently.
///
/// To use, import `package:syncfusion_flutter_calendar/calendar.dart`.
///
/// See also:
/// * [Syncfusion Flutter Calendar product page](https://www.syncfusion.com/flutter-widgets/flutter-calendar)
/// * [User guide documentation](https://help.syncfusion.com/flutter/calendar/overview)
/// * [Knowledge base](https://www.syncfusion.com/kb/flutter)
library calendar;

export 'src/calendar/appointment_engine/appointment.dart';
export 'src/calendar/appointment_engine/calendar_datasource.dart';
export 'src/calendar/appointment_engine/recurrence_properties.dart';
export 'src/calendar/common/calendar_controller.dart';
export 'src/calendar/common/enums.dart';
export 'src/calendar/common/event_args.dart';
export 'src/calendar/resource_view/calendar_resource.dart';
export 'src/calendar/settings/drag_and_drop_settings.dart';
export 'src/calendar/settings/header_style.dart';
export 'src/calendar/settings/month_view_settings.dart';
export 'src/calendar/settings/resource_view_settings.dart';
export 'src/calendar/settings/schedule_view_settings.dart';
export 'src/calendar/settings/time_region.dart';
export 'src/calendar/settings/time_slot_view_settings.dart';
export 'src/calendar/settings/view_header_style.dart';
export 'src/calendar/settings/week_number_style.dart';
export 'src/calendar/sfcalendar.dart';
